//**************************************************************************************************
//*  FRIDA: fast reliable interactive data analysis
//*  (C) Joachim Wuttke 1990-, v2(C++) 2001-
//*  http://apps.jcns.fz-juelich.de/frida
//**************************************************************************************************

//! \file  loop.hpp
//! \brief Declares iterator over file selection.

#ifndef LOOP_H
#define LOOP_H

class COlo;
class COld;
class COlc;


//! Iterate over all files in selection.

class FileIterator
{
private:
    int iV;
    vector<int> Sel;

public:
    FileIterator(const vector<int>& _Sel, bool tolerate_empty = false);
    void reset() { iV = -1; }
    int k() const;
    int iteration() const { return iV; }
    int size() const { return Sel.size(); }
    // return current file, and advance iterator:
    COlo* current();
    COld* currentD();
    COlc* currentC();
    COlo* next()
    {
        ++iV;
        return current();
    }
    COld* nextD()
    {
        ++iV;
        return currentD();
    }
    COlc* nextC()
    {
        ++iV;
        return currentC();
    }
};

#endif // LOOP_H
